
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JAVA8--Stream学习 / iVAN</title>

    <meta name="description" content="JAVA8--Stream学习 Stream是什么 怎么使用Stream Stream的建立 Stream中的元素操作 Stream聚合操作 Stream结果处理 Stream分组操作 Stream注意事项 Stream是什么 书上说Stream是对JAVA中对集合处理的抽象,在我看来Stream更像是对java集合的一次扩展,因为Stream中的API都是我们对集合操作中可能遇到的问题.那为什么要用Stream呢?可以从两个方面去考虑,一方面,使得集合处理可以更加高效,Stream可以并行执行.另一方面,代码更佳优雅,更加简">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JAVA8--Stream学习</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<ul>
<li>
<ul>
<li>
<ul>
<li>Stream是什么</li>
<li>怎么使用Stream</li>
<li>Stream的建立</li>
<li>Stream中的元素操作</li>
<li>Stream聚合操作</li>
<li>Stream结果处理</li>
<li>Stream分组操作</li>
<li>Stream注意事项</li>
</ul>
</li>
</ul>
</li>
</ul>
<h3>Stream是什么</h3>
<p>书上说Stream是对JAVA中对集合处理的抽象，在我看来Stream更像是对java集合的一次扩展，因为Stream中的API都是我们对集合操作中可能遇到的问题。那为什么要用Stream呢？可以从两个方面去考虑，一方面，使得集合处理可以更加高效，Stream可以并行执行。另一方面，代码更佳优雅，更加简短，因为Stream中也用到了函数式编程接口。</p>
<p>举一个例子来看使用Stream的优势。对一个String集合中的所有字符串做统计，找出长度大于5的字符串。</p>
<pre><code>//集合内容
List&lt;String&gt; list = new ArrayList&lt;&gt;();
list.add("a");
list.add("bc");
list.add("def");
list.add("ghij");
list.add("kmlno");
list.add("pqrstu");</code></pre>
<p>使用传统的集合操作</p>
<pre><code>int count =0;
for(String s : list){
    if (s.length()&gt;5){
        count++;
    }
}</code></pre>
<p>使用Stream API进行处理</p>
<pre><code>//串行执行
long count = list.stream().filter(s-&gt;s.length()&gt;5).count()
//并行执行
long count = list.parallelStream().filter(s-&gt;s.length()&gt;5).count()</code></pre>
<p>相比于传统的迭代的模式，使用Stream对集合进行操作会更加简洁、方便、高效。</p>
<h3>怎么使用Stream</h3>
<p>使用Stream只需要三个步骤：</p>
<ul>
<li>创建一个Stream</li>
<li>指定这个Stream要做的操作</li>
<li>使用一个<strong>终止动作</strong>来使得Stream产生结果</li>
</ul>
<p>上面的字符串长度统计的例子中，<code>list.stream()</code>用来建立了一个Stream，<code>filter(s-&gt;s.length()&gt;5)</code>告诉了这个流要做哪些事情，最后使用<code>count</code>操作来强制它之前的延迟操作立即执行。Stream执行的一个特点就是延迟执行，count方法被调用的时候才会执行Stream之前定义的操作。另外，Stream执行的过程中不会对源对象产生改变，它们会返回一个新的Stream。</p>
<h3>Stream的建立</h3>
<p>JAVA8在Collection接口中添加了stream方法，所以我们可以将任何集合转换为一个Stream。另外我们也可以通过<code>Stream.of</code>方法将一个数组转换为Stream。</p>
<pre><code>//集合到Stream
Stream&lt;String&gt; stream = list.stream();
//数组到Stream
String contents = "a,b,c,d,e";
Stream&lt;String&gt; stream = Stream.of(contents.split(","));
//构造含有任意个数的Stream,Stream.of方法接受可变长度的参数
Stream&lt;String&gt; stream = Stream.of("q","w","e","r");</code></pre>
<p>另外还可以建立无限序列，如建立一个行如0 1 2 3 4 5 …的无限序列</p>
<pre><code>Stream&lt;BigInteger&gt; stream = Stream.iterate(BigInteger.ZERO,n-&gt;n.add(BigInteger.ONE));</code></pre>
<p>另外一种创建无限Stream的方法是generate方法，当需要一个Stream值的时候就会调用该方法来产生一个包含随机数的无限流。</p>
<pre><code>Stream&lt;Double&gt; stream = Stream.generate(Math::random);</code></pre>
<h3>Stream中的元素操作</h3>
<p>Stream的过滤操作可以使用filter方法，该方法会返回一个<strong>新的流</strong>，这个流中的元素满足一定的条件。接口方法的定义如下所示</p>
<pre><code>Stream&lt;T&gt; filter(Predicate&lt;? super T&gt; predicate);</code></pre>
<p>该方法的参数是一个<code>Predicate&lt;T&gt;</code>对象，是一个从T-&gt;boolean的函数。</p>
<p>如果需要对一个流中的每个元素都做一定的转换操作而不是进行条件过滤，如将一个字符串流中每个元素变为小写，那么可以使用map方法。</p>
<pre><code>Stream&lt;String&gt;  stream = list.stream().map(String::toLowerCase);    </code></pre>
<p>在使用迭代方式对集合进行处理的过程中，我们可以通过控制台打印的方式查看元素的执行情况。</p>
<pre><code>for(集合){
...
打印元素，观察状态
...
}</code></pre>
<p>在使用Stream流的过程中，可以使用peek方法完成相同的事情。该方法会产生一个与原始流具有相同元素的流，但是在每次获取一个元素时，都会调用一个函数，这样利于调试。</p>
<pre><code>String[]  stream =list.stream().peek(e-&gt;System.out.println("Fetching:"+e)).map(String::toLowerCase).toArray(String[]::new);</code></pre>
<p>执行结果：</p>
<pre><code>Fetching:a
Fetching:bc
Fetching:def
Fetching:ghij
Fetching:kmlno
Fetching:pqrstu</code></pre>
<p>如果只是简单的打印流里面的元素，可以使用</p>
<pre><code>list.stream().forEach(System.out::println)</code></pre>
<h3>Stream聚合操作</h3>
<p>前面说过流的执行过程是延迟执行，当一个流遇到了终止操作后，它前面的操作才会执行。聚合方法都是终止操作。它会将<strong>流聚合为一个值</strong>。常用的聚合方法有返回流中的元素总数count方法。返回流中的最大值和最小值的max和min方法。findFirst方法返回非空集合中的第一个值。findAny方法返回所有匹配的元素。anyMatch方法返回流中是否有匹配的元素。 <br />
例子：</p>
<pre><code>Optional&lt;String&gt; optional =  list.stream().max(String::compareToIgnoreCase);
if (optional.isPresent()){
System.out.println(optional.get());
}</code></pre>
<p>在执行这些方法时，返回值有可能为空，如果对返回值不加以判断就直接执行之后的代码，很有可能会引起空指针异常。JAVA8中推出了一个<code>Optional&lt;T&gt;</code>类型，这是一种更好表示缺少返回值的方式。它是对一个T类型对象的封装或者表示不是任何对象，它比一般的指向T类型的引用更加安全。但是从上面的例子可以看出，使用Optional跟以前的直接对返回值进行判断并没有什么简化。如果没有设计Optional，那么上面的代码调用可能是下面的方式。</p>
<pre><code>T value =  list.stream().max(String::compareToIgnoreCase);
if (value != null){
System.out.println(value);
}</code></pre>
<p>所以高效使用Optional的关键是把它当作一个中间结果，我们可以把这个中间结果传递给其它函数做处理。基本形式： <br />
聚合值-&gt;Optional-&gt;函数处理，如我们要把上面比较的结果添加到一个result集合中去，那么可以使用</p>
<pre><code>optional.ifPresent(value -&gt; result.add(value));</code></pre>
<p>有关Optional的详细信息可以参考这篇博文： <a href="http://www.importnew.com/6675.html" rel="external nofollow noreferrer">Java 8 Optional类深度解析</a></p>
<h3>Stream结果处理</h3>
<p>在流处理的过程中，通常是要把处理的结果转换为集合对象，而不是要聚合为一个值。 <br />
流-&gt;数组</p>
<pre><code>String[] result = list.stream().toArray(String[]::new)</code></pre>
<p>流-&gt;set</p>
<pre><code>Set&lt;String&gt; result = list.stream().collect(Collectors.toSet());</code></pre>
<p>流-&gt;list</p>
<pre><code>List&lt;String&gt; result = list.stream().collect(Collectors.toList());</code></pre>
<p>流-&gt;map <br />
由于map是k－v形式，所以要指明KV。如我们有一个<code>Stream&lt;Person&gt;</code>对象，将它的id和name存入map中。</p>
<pre><code>Map&lt;Integer,String&gt; idToName = stream.collect(Collectors.toMap(Person::getId,Person::getName))</code></pre>
<p>如果key为id，值为person对象可以用以下方法获取map，如果key重复，会抛出异常。</p>
<pre><code>Map&lt;Integer, Person&gt; idToPerson = stream.collect(Collectors.toMap(Person::getId, Function.identity()));</code></pre>
<h3>Stream分组操作</h3>
<p>分组操作实际上是对map操作的一种简化与补充。如我们现在需要得到一个map，key为国家名，value为改国家所使用的语言。可以用以下代码实现：</p>
<pre><code>Stream&lt;Locale&gt; locales = Stream.of(Locale.getAvailableLocales());

Map&lt;String, Set&lt;String&gt;&gt; countryLanguageSets = locales.collect(
Collectors.toMap(Locale::getDisplayCountry,
l -&gt; Collections.singleton(l.getDisplayLanguage()),
(a, b) -&gt; {
Set&lt;String&gt; r = new HashSet&lt;&gt;(a);
r.addAll(b);
return r; }
));</code></pre>
<p>与上面生成map的方法相比，该方法多了一个参数，第三个参数的作用是在发现了一个国家的一种新语言时，我们将已有值和新值组成一个新的集合。上面实际上是对locale流按照国家来分组。所以也可以用以下代码实现</p>
<pre><code>Map&lt;String, List&lt;Locale&gt;&gt; countryToLocales = locales.collect(
Collectors.groupingBy(Locale::getCountry));</code></pre>
<p>Locale::getCountry为分组的依据。如果我们需要对分组后的结果在做一些处理，如转换为set或统计数量</p>
<pre><code>locales = Stream.of(Locale.getAvailableLocales());
Map&lt;String, Set&lt;Locale&gt;&gt; countryToLocaleSet = locales.collect(
groupingBy(Locale::getCountry, Collectors.toSet()));
System.out.println("countryToLocaleSet: " + countryToLocaleSet);   

locales = Stream.of(Locale.getAvailableLocales());
Map&lt;String, Long&gt; countryToLocaleCounts = locales.collect(
groupingBy(Locale::getCountry, counting()));
System.out.println("countryToLocaleCounts: " + countryToLocaleCounts);  </code></pre>
<h3>Stream注意事项</h3>
<p>当执行一个流操作时，并不会对底层的集合进行修改。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-07 07:32:03</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JAVA8--Stream学习的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boRERjz.html" rel="bookmark">&lbrack;译&rsqb; 大战 RxJava2 和 Java8 Stream &lbrack; Android RxJava2 &rsqb; （这到底是什么） 第四部分</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是[译] 大战 RxJava2 和 Java8 Stream [ Android RxJava2 ] (这到底是什么) 第四部分, 原文地址:War against Learning Curve of RxJava2 + Java8 Stream [ Android RxJava2 ] ( What the hell is this ) Part4 原文作者:Hafiz Waleed Hussain 译文出自:掘金翻译计划 译者: Boiler Yao 校对者: Vivienmm.Git			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rjBJz.html" rel="bookmark">Java8 Stream API介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Stream API是Java8中处理集合的关键组件,提供了各种丰富的函数式操作. Stream的创建 任何集合都可以转换为Stream: //数组 String[] strArr = new String[]{&quot;aa&quot;,&quot;bb&quot;,&quot;cc&quot;}; Stream&lt;String&gt; streamArr = Stream.of(strArr); Stream&lt;String&gt; streamArr2 = Arrays.stream(st			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pL7kqWM.html" rel="bookmark">Java8并发教程：Threads和Executors</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				欢迎阅读我的Java8并发教程的第一部分.这份指南将会以简单易懂的代码示例来教给你如何在Java8中进行并发编程.这是一系列教程中的第一部分.在接下来的15分钟,你将会学会如何通过线程,任务(tasks)和 exector services来并行执行代码. 第一部分:Threads和Executors 第二部分:同步和锁 并发在Java5中首次被引入并在后续的版本中不断得到增强.在这篇文章中介绍的大部分概念同样适用于以前的Java版本.不过我的代码示例聚焦于Java8,大量使用lambda表达式			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGE59eM.html" rel="bookmark">stream-Java8 Stream中我如何对多个属性groupingBy</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Java8 Stream中我如何对多个属性groupingBy 我已经从获得了一个Log的list public class Log(){ private int id; private String user; private String mod; private Timestamp logtime; .......getter and setter } List loglist = logdao.getLogList(); 我想对Log的 user和mod字段进行进行分组统计,我			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pn65Xop.html" rel="bookmark">Java8初体验系列文章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java8初体验系列文章,是我自学Java8的过程中把自己的理解和体会记录下来,供大家参考和讨论. lambda表达式语法 Sream语法详解 未完待续... ps:本人也还在Java8的学习中,所以后面文章的更新周期可能不会特别固定,敬请体谅. 文章转自 并发编程网-ifeve.com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ybjA8mz.html" rel="bookmark">浅析Java 8的聚合操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Oracle在2014年3月19日如期发布了Java 8.Java 8版本被认为是具有里程碑意义的一个版本,Oracle在该版本中添加了许多新特性,包括Lambda表达式.方法引用.加强了安全等等. 在众多的新特性中,聚合操作(Aggregate Operations)是针对集合类的一个比较大的变化.通过聚合操作,开发者可以更容易地使用Lambda表达式,并且更方便地实现对集合的查找.遍历.过滤以及常见计算等. 聚合操作与Java 8中的Lambda表达式.方法引用等新特性是相关的,一般一起组合			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40RBNz.html" rel="bookmark">Java8初体验（二）Stream语法详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				感谢同事[天锦]的投稿.投稿请联系 tengfei@ifeve.com 上篇文章Java8初体验(一)lambda表达式语法比较详细的介绍了lambda表达式的方方面面,细心的读者会发现那篇文章的例子中有很多Stream的例子.这些Stream的例子可能让你产生疑惑,本文将会详细讲解Stream的使用方法(不会涉及Stream的原理,因为这个系列的文章还是一个快速学习如何使用的). 1. Stream初体验 我们先来看看Java里面是怎么定义Stream的: A sequence of elem			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOm9AmM.html" rel="bookmark">Java8初体验（二）Stream语法详解---符合人的思维模式，数据源--》stream--&amp;gt&semi;干什么事（具体怎么做，就交给Stream）--》聚合</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				感谢同事[天锦]的投稿.投稿请联系 tengfei@ifeve.com上篇文章Java8初体验(一)lambda表达式语法比较详细的介绍了lambda表达式的方方面面,细心的读者会发现那篇文章的例子中有很多Stream的例子.这些Stream的例子可能让你产生疑惑,本文将会详细讲解Stream的使用方法(不会涉及Stream的原理,因为这个系列的文章还是一个快速学习如何使用的). 1. Stream初体验 我们先来看看Java里面是怎么定义Stream的: A sequence of eleme			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/rz4Yaqb.html" rel="bookmark">java8 如何进行stream reduce&comma;collection操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.概念介绍     在java8 JDK包含许多聚合操作(如平均值,总和,最小,最大,和计数),返回一个计算流stream的聚合结果.这些聚合操作被称为聚合操作.JDK除返回单个值的聚合操作外,还有很多聚合操作返回一个collection集合实例.很多的reduce操作执行特定的任务,如求平均值或按类别分组元素.     JDK提供的通用的聚合操作:Stream.reduce,Stream.collection     注意:本文将reduction operations翻译为聚合操作,因为r			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlBqm8z.html" rel="bookmark">Java8：Lambdas&lpar;二&rpar;学习怎样去使用lambda表达式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接  作者:Ted Neward   译者:赵峰 Java SE 8的发布很快就到了.伴随着它来的不仅仅是新的语言lambda表达式(同样被称为闭包或匿名方法)--伴随着一些语言特性支持--更重要的是API和library的增强将会使传统的Java核心libraries变的更易于使用.其中大多数的增强和补充是在Collections API中,因为Collections API在整个应用中随处可见,这篇文章大部分是在讨论它. 然而 ,很有可能大多数的Java开发者将不会熟悉隐藏在lambd			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjG9mM.html" rel="bookmark" class="title">只有一个复选框的全选处理</a>
					<div>
						复选框 网页中经常需要动态的生成多个复选框,通常还有一个&quot;全选&quot;按纽用来选定全部复选框或者全部取消选定. 但需要注意的一个问题是当只剩下一个复选框的时候就无法使用复选框length ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM17aaz.html" rel="bookmark" class="title">菜鸟学用Dreamweaver MX 2004行为教程</a>
					<div>
						dreamweaver|教程 1.菜鸟学用Dreamweaver MX 2004行为(16)设置文本 [2005-03-08]     2.菜鸟学用Dreamweaver MX 2004行为(15)显 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM17Kjz.html" rel="bookmark" class="title">MySQL数据库结构和数据的导出和导入</a>
					<div>
						mysql|数据|数据库|数据库结构 作者:任我行导出要用到MySQL的mysqldump工具,基本用法是: shell&gt; mysqldump [OPTIONS] database [table ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMgrP6b.html" rel="bookmark" class="title">交互设计思想&colon;思维盲点</a>
					<div>
						读&lt;明朝那些事儿&gt;,朱棣起兵造反欲取建文帝而代之,在离胜利只差一步的时候,朱棣陷入思维陷阱.朱棣得知京师空虚,如果此时出击京师必可得胜,但是此时朱棣在北平建文帝京师在南京,而在通往南京的路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo5XDp.html" rel="bookmark" class="title">彻底解决Tomcat 5&period;0&period;19中文乱码&lpar;过滤器&rpar;</a>
					<div>
						一.Include的页面乱码 现象:include进来的页面出现乱码,其它页面正常. 原因:Tomcat在缺省情况下使用ISO-8859-1编码,但是在include时有时Tomcat不能正确根据外层 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNE9kdb.html" rel="bookmark" class="title">ASP 连接 SQL SERVER 2008的方法</a>
					<div>
						 现在很多朋友使用了sql2008,但原来2000的代码已经无法使用了,这里分享下asp连接sql2008的方法,需要的朋友可以参考下 虽然网上有很多介绍,但是我还是费了很大的劲才连上.(要安装IIS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOxyBb.html" rel="bookmark" class="title">Dreamweaver正则表达式教程</a>
					<div>
						正则表达式是以文本描述字符组合的模式.在代码搜索中使用它们有助于描述一些概念,例如以&quot;以'var'开始的行&quot;和&quot;包含数字的属性值&quot;.有关搜索的更多信息,请参见搜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd71J3M.html" rel="bookmark" class="title">Youku 视频绝对地址获取的方法详解</a>
					<div>
						前一阵子为了研究 KnLiveCommentary 而进行了一系列的关于视频站点的研究.由于KnLiveCommentary需要能够获取充足的视频源进行测试,所以我们选取了 Youku(优酷)一个比较 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPN0o1b.html" rel="bookmark" class="title">界面交互设计文档是什么文档 该怎么编写？</a>
					<div>
						文档是什么文档 该怎么编写?-vc编写人机交互界面&quot;&gt; 离开交互圈已经有段时间了.但由于博客还在,还是能够偶尔收到一些邮件,上周有位同学问我:我在求职,我看到很多招聘说明上需要交互设计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6Vejz.html" rel="bookmark" class="title">WPS标尺在哪里</a>
					<div>
						  1.按照下图,单击左上色的蓝色图标[WPS文字] 2.在弹出的窗口中,点击'选项',调出'选项'对话框,视图中,勾选'垂直标尺',点击确定退出. 3.在'视图'选项卡下,'显示'功能区中勾选'标尺 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6aAwb.html" rel="bookmark" class="title">tk-perl中pause命令的应用</a>
					<div>
						问题描述 perl中pause命令的应用 我写的代码,如下图,为什么第二个PAUSE命令运行不起来?放在窗口代码之前或者之间就可以运行,但是在窗口代码之后,就运行不了,到底什么情况?顺便问下关于per ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPqLrp.html" rel="bookmark" class="title">CHROME扩展：HOVER ZOOM</a>
					<div>
						很多UI设计师都喜欢去 Dribbble.Flickr 等网站上获取设计和摄影灵感,又或者去 Reddit 上浏览趣图,但每次都需要点击缩略图去查看大图,这无疑是浪费时间的. Hover Zoom 正 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YORkM.html" rel="bookmark" class="title">诚心请教，关于培训的问题。很迷茫，希望有前辈能指点一下。</a>
					<div>
						问题描述 我是09年毕业的本科生,学校一般.很难找工作.现在很多培训都说可以推荐工作的,是不是真的哦? 有人了解中软和神州数码北京的培训吗?质量,诚信怎么样? 是不是真能推荐好工作? 本人现在很迷茫, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWRRkz.html" rel="bookmark" class="title">lazarus如何制作截屏工具</a>
					<div>
						问题描述 lazarus如何制作截屏工具 如题,我用lazarus,如何制作一个可以截屏的工具,能录像就更好了,谢谢! 解决方案 linux下截屏工具linux下截屏工具					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94JEKb.html" rel="bookmark" class="title">java学习：jdbc连接示例</a>
					<div>
						java中最常用的数据库连接技术就是JDBC. 目前几乎所有的主流数据库都提供了相应的jdbc驱动,可以简单理解为.net中的数据库客户端dll,.net中如果对于netframework默认不支持的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6ZdXyM.html" rel="bookmark" class="title">ASP&period;NET配合jQuery解决跨域调用的问题&lowbar;实用技巧</a>
					<div>
						一. 使用JSONp方式调用 不做详细讲解,可以参考jq文档&lt;jQuery 1.10.3 在线手册&gt; 二. 服务端配置 修改Web.config 文件 &lt;system.webServ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5Y05M.html" rel="bookmark" class="title">一个移动互联网应用地图服务架构</a>
					<div>
						在移动互联网中,各种与位置相关的服务都严重依赖于地图服务,地图服务质量的好坏很大程度决定了所提供服务的高低.尽管有Google Map等免费或收费的地图服务可供使用,但没有那一家地图服务提供商能够完整 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z40Borz.html" rel="bookmark" class="title">网页控件不能用？让Chrome插上IE的翅膀</a>
					<div>
						很多银行的网银对Chorme.Firefox之类的非IE浏览器支持度不好是一个长久的问题,有些是提供了控件安装但是不好用,有些干脆是不支持.有没有办法让非IE浏览器也能正常浏览.操作这些网页呢? 其实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5K4eM.html" rel="bookmark" class="title">iComet聊天Demo增加好友列表和离线存储</a>
					<div>
						最新版的 icomet 长连接/push 服务器的聊天 Demo 升级了, 做了如下更新: 美化界面, 更好看了. 增加好友列表, 能显示全部好友和最近联系人. 离线存储消息. 界面截图: Web界面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RonRz.html" rel="bookmark" class="title">授权-simatic manager 如何 注册</a>
					<div>
						问题描述 simatic manager 如何 注册 网上下载了step7v5.5,安装后提示没有授权,不能使用,求指点如何免费注册!!!! 解决方案 step7据我所知,在没有授权的情况下也可以使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7xQ8Xb.html" rel="bookmark" class="title">调查显示美国人不放心云存储个人数据</a>
					<div>
						北京时间10月25日上午消息,据国外媒体报道,网络安全咨询公司Unisys公布的美国安全指数调查显示,美国人并不放心将他们的秘密数据进行云存储,担心数据被窃是他们的头号安全顾虑.在最新的调查中,当被问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y9o3z.html" rel="bookmark" class="title">linux dial up-linux CentOS6&period;5中 dial-up module is not enabled</a>
					<div>
						问题描述 linux CentOS6.5中 dial-up module is not enabled 求各位大神指导,本人刚接触Linux,现在就卡在这连不上网!!! linux CentO怎么解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX08KWp.html" rel="bookmark" class="title">Equinox结合Swing</a>
					<div>
						问题描述 我利用Equinox设计实现model在SwingApplication中的显示,但是与传统的Swing程序不同,原本的Swing程序通过main方法来启动和实现界面的加载等,因此原有的sw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJq8L7p.html" rel="bookmark" class="title">甲骨文投资人不满埃里森薪酬</a>
					<div>
						甲骨文投资人已越来越对公司首席执行官拉里·埃里森(Larry Ellison)的高薪酬问题感到不满.在10月31日举行的甲骨文年度股东大会中,这一问题或许将成为甲骨文股东讨论的焦点问题. 甲骨文上周五 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBLrOz.html" rel="bookmark" class="title">围绕&OpenCurlyDoubleQuote;霄龙&rdquo;扩大产业链，或是AMD重返中国服务器市场的一个策略</a>
					<div>
						CNET科技行者 8月24日 北京消息(文/周雅):继6月20日奥斯汀发布会之后,AMD昨天正式将全套EPYC 7000系列数据中心处理器家族带到中国. 整场发布会的重头戏,是包括腾讯.京东.百度.联 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmV4Vaz.html" rel="bookmark" class="title">ASP&period;NET Eval进行数据绑定的方法&lowbar;实用技巧</a>
					<div>
						假设你已经了解ASP.NET Eval 1.1的数据绑定(特别是Container这个局部变量)的机制,这里主要分析ASP.NET Eval 2.0数据绑定做了那些改进. ASP.NET Eval 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW0r3z.html" rel="bookmark" class="title">JavaScript 动态添加表格行 使用模板、标记&lowbar;javascript技巧</a>
					<div>
						对于复杂的操作情况,比如:添加一行之后,在这一行上还要进行相关的操作会显得有些吃力:本人比较喜欢表现层使用模板.标记填充数据的做法,于是自己做手做了个小组件,与大家一起分享. 组件运行截图: 设计思路 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mqg2yGz.html" rel="bookmark" class="title">说智能手机已经成为人手一部的&OpenCurlyDoubleQuote;标配&rdquo;产品</a>
					<div>
						&quot;买的放心&quot; HTC打造完善的售后服务体系 类型:原创 作者:许威 时间:2014-05-15 11:23:35 [手机中国 新闻]虽说智能手机已经成为人手一部的&quot;标配& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwyxanM.html" rel="bookmark" class="title">数据库表id-数据库中id自增，数据库其他表也出现了类似的问题，问题如下</a>
					<div>
						问题描述 数据库中id自增,数据库其他表也出现了类似的问题,问题如下 数据库中id自增1,后来添加数据后自加了近1000后又持续+1,数据库其他表也出现了类似的问题 ID如:1,2,3,4,5,6,7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWd0XEp.html" rel="bookmark" class="title">《Java和Android开发学习指南（第2版）》&mdash;&mdash; 2&period;4 变量</a>
					<div>
						2.4 变量 变量是数据占位符.Java是一种强类型的语言,因此,每个变量必须有一个声明的类型.Java中有两种数据类型: 引用类型一个引用类型的变量,提供对一个对象的引用.基本类型一个基本类型的变量 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
